﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.IO;
using System.Windows.Forms; // MessageBox
using System.Collections;// ArrayList

namespace Suchen
{
    public class SearchThread
    {
        public enum SearchModi { AllFiles, Pictures, Media };
        SearchModi modi = SearchModi.AllFiles;
        ArrayList filelist = new ArrayList();

        private String actualDir = "";
        public long summe = 0;
        public long anzFiles = 0;
        private IPrintResult parent;

        public SearchThread(IPrintResult parent, String actualDir, SearchModi modi)
        {
            this.actualDir = actualDir;
            this.parent = parent;
            this.modi = modi;
            switch (modi)
            {
                case SearchModi.Pictures:
                    filelist.Add(".bmp");
                    filelist.Add(".cpt");
                    filelist.Add(".cr2");
                    filelist.Add(".crw");
                    filelist.Add(".dcm");
                    filelist.Add(".djvm");
                    filelist.Add(".flv");
                    filelist.Add(".gho");
                    filelist.Add(".gif");
                    filelist.Add(".ico");
                    filelist.Add(".jpeg");
                    filelist.Add(".jpg");
                    filelist.Add(".mix");
                    filelist.Add(".pcx");
                    filelist.Add(".png");
                    filelist.Add(".raw");
                    filelist.Add(".tga");
                    filelist.Add(".tif");
                    filelist.Add(".tiff");
                    filelist.Add(".wmv");
                    break;
                case SearchModi.Media:
                    filelist.Add(".aif");
                    filelist.Add(".aifc");
                    filelist.Add(".aiff");
                    filelist.Add(".asf");
                    filelist.Add(".asx");
                    filelist.Add(".au");
                    filelist.Add(".avi");
                    filelist.Add(".cda");
                    filelist.Add(".dvr-ms");
                    filelist.Add(".flac");
                    filelist.Add(".ivf");
                    filelist.Add(".m1v");
                    filelist.Add(".m2u");
                    filelist.Add(".mid");
                    filelist.Add(".midi");
                    filelist.Add(".mov");
                    filelist.Add(".mp2");
                    filelist.Add(".mp3");
                    filelist.Add(".mp4");
                    filelist.Add(".mpa");
                    filelist.Add(".mpe");
                    filelist.Add(".mpeg");
                    filelist.Add(".mpg");
                    filelist.Add(".mpv2");
                    filelist.Add(".qt");
                    filelist.Add(".ra");
                    filelist.Add(".ram");
                    filelist.Add(".rm");
                    filelist.Add(".rmi");
                    filelist.Add(".snd");
                    filelist.Add(".wav");
                    filelist.Add(".wax");
                    filelist.Add(".wm");
                    filelist.Add(".wma");
                    filelist.Add(".wmd");
                    filelist.Add(".wms");
                    filelist.Add(".wmv");
                    filelist.Add(".wmz");
                    filelist.Add(".wpl");
                    filelist.Add(".wvx");
                    break;
            }
        }

        public void run()
        {
            calc(actualDir);
            parent.printStatus("");
            parent.printResult();
            // MessageBox.Show("ende");
        }

        private void calc(String actualDir)
        {
            bool bOk;
            try
            {
                parent.printStatus(actualDir);

                String[] subDirs = Directory.GetDirectories(actualDir);
                String[] files = Directory.GetFiles(actualDir);
                foreach (String file in files)
                {
                    bOk = true;
                    if (filelist.Count > 0)
                    {
                        bOk = false;
                        foreach (String ext in filelist)
                        {
                            if (file.ToLower().EndsWith(ext))
                            {
                                bOk = true;
                                break;
                            }
                        }
                    }
                    if (bOk)
                    {
                        anzFiles++;
                        long len = new FileInfo(file).Length;
                        summe += len;
                        parent.printFile(file);
                    }
                }
                foreach (String dir in subDirs)
                {
                    FileAttributes fileAttributes =
                        File.GetAttributes(dir);
                    bool isHidden =
                        (fileAttributes & FileAttributes.Hidden)
                        == FileAttributes.Hidden ||
                    (fileAttributes & FileAttributes.System)
                                    == FileAttributes.System;

                    if (!isHidden)
                    {
                        calc(dir);
                    }

                } // foreach
            }
            catch (System.UnauthorizedAccessException e)
            {
            }
        }  // calc


    }
}
